## Pypass

<p>
<img src="https://img.shields.io/badge/Built%20with-Python3.8-blue"/>
<img src="https://img.shields.io/badge/Version-0.0.1-blue"/>
<p>

Pypass offers a way to store and organise passwords locally from the comfort of your terminal. It has the following features:

- Multiuser support
- Crossplatform (Windows & Linux)
- Safe encryption
- Basic crud operations on models
- Minimal configuration and efficiency
- Keepass alike functionality when copying credentials
- Session persistance

In order to keep the multiuser feature safe, the session lasts for 10 minutes. After 10 minutes you will have to log in again. 

On Linux the session file is stored in `/tmp`, meaning that even if the session time is less than 10 minutes if you restart your system it will be deleted and you will have to log in again.

![](https://s1.gifyu.com/images/ezgif.com-gif-maker39c36d14a9473aad.gif)

### Installation

*Know that [pipx](https://github.com/pypa/pipx) is highly encouraged when installing this kind of tools as it makes easier to run them as standalones*

`pip install cmpypass`

or

`pipx install cmpypass`


### Getting started 

1. Create the db file with `pypass --cdb`
2. Create your user and log in, see `--help` for `u` command
3. Add some categories
4. At this point you can start saving your credentials

### Debug mode

If you want to see log outputs to debug the application you must set an environment variable:

**In Windows**

`setx PYPASS_LOG=true`

**In Linux**

`export PYPASS_LOG=true`

The `--debug` option will print information relative to the app version and the folders where the session and the db file are being stored.


### License

This project is under [MIT LICENSE](https://github.com/carlos-molero/pypass/blob/master/LICENSE) in the name of Carlos Molero. Uploading this project to any other place than the present one without explicit consent and attribution is prohibited.
