from termcolor import colored
from getpass import getpass

from cmpypass.services.pypass_svc import add_pypass, copy_pypass, delete_pypass, list_pypasses, list_pypasses_by_category, update_pypass


def execute(args):
    if args.a is not None and len(args.a.split(":")) < 2:
        print(colored("Improper format, it must be arg1:arg2", "red"))
        return
    if args.a is not None:
        username = args.a.split(":")[0]
        category = args.a.split(":")[1]
        print(colored(" Write a name for this store: ", "magenta"))
        name = input("> ")
        print(colored(" Write a password: ", "magenta"))
        password = getpass("> ")
        print(colored(" Confirm password: ", "magenta"))
        password_match = getpass("> ")
        if password == password_match:
            add_pypass(name, username, category, password)
            return
        print(colored("Passwords do not match", "red"))
    elif args.la:
        list_pypasses()
    elif args.l is not None:
        list_pypasses_by_category(args.l)
    elif args.cp is not None:
        if args.cp[1] == "uname" or args.cp[1] == "pwd":
            copy_pypass(args.cp[0], args.cp[1])
        else:
            print(colored(f"{args.cp[1]} option is not supported. Supported options ['uname','pwd']", "red"))
    elif args.d is not None:
        delete_pypass(args.d)
    elif args.u is not None:
        update_pypass(args.u)