from sqlalchemy.sql.functions import user
from termcolor import colored
from getpass import getpass

from cmpypass.services.user_svc import create_user, list_users, log_in, log_out
from cmpypass.services.cache_svc import get_logged_user, set_logged_user

logged_user = get_logged_user()

def execute(args):
        if args.c is not None:
            username = args.c
            print(colored(" Write a password: ", "magenta"))
            password = getpass("> ")
            print(colored(" Confirm password: ", "magenta"))
            password_match = getpass("> ")
            if password == password_match:
                create_user(username, password)
                return
            print(colored("Passwords do not match", "red"))
        elif args.login is not None:
            username = args.login
            print(colored("Write a password: ", "magenta"))
            password = getpass("> ")
            user = log_in(username, password)
            if user is not None:
                set_logged_user(user)
                return
            print(colored("The provided username and password pair does not match", "red"))
            print("You can create an user running u --c yourusername")
        elif args.l:
            list_users()
        elif args.logout:
            log_out()
        elif args.who:
           message = f"You're logged in as " + colored(logged_user.name, "magenta") if logged_user is not None else colored("You're not logged in", "red")
           print(message)
                