import pickle
import os
import time
from sqlalchemy.orm.session import Session
from termcolor import colored

from cmpypass.helpers.route_helpers import get_current_file_route
from cmpypass.db import User, get_session
from cmpypass.helpers.log_helpers import LogLevels, log

current_file_route = get_current_file_route()

def set_logged_user(u):
    logged_user = u
    logged_user.password = ""
    with open(current_file_route, "wb+") as f:
        pickle.dump(logged_user, f, protocol=pickle.HIGHEST_PROTOCOL)

def get_logged_user():
    try:
        with open(current_file_route, 'rb') as f:
            user = pickle.load(f)
            s:Session = get_session()
            existant_user = s.query(User).filter(User.name == user.name).first()
            s.close()
            if existant_user is not None:
                return user
            return None
    except:
        return None

def remove_logged_user():
    try:
        os.remove(current_file_route)
    except:
        print(colored("No user logged in", "red"))

def remove_current_user_file_by_time(ms):
    try:
        modified_time = os.path.getmtime(current_file_route)
        log(LogLevels.DEBUG, f"Session duration: {ms / 60} min")
        if (time.time() - modified_time) > ms:
            os.remove(get_current_file_route())
            log(LogLevels.WARN,"Session expired, current user file removed")
    except Exception as e:
        log(LogLevels.ERROR, str(e))
