from sqlalchemy.orm.session import Session
from termcolor import colored

from cmpypass.services.cache_svc import get_logged_user, remove_logged_user, set_logged_user
from cmpypass.services.encryption_svc import get_encrypted_password, get_decrypted_password
from cmpypass.db import get_session, User

logged_user = get_logged_user()

def create_user(name, password):
    try:
        s:Session = get_session()
        existant_user = s.query(User).filter(User.name == name).first()
        if existant_user is None:
            u = User(name, get_encrypted_password(password))
            s.add(u)
            s.commit()
            print(f'User {colored(name, "magenta")} {colored("succesfully created", "green")}')
            return
        print(colored(f"User {name} already exists", "red"))
    except:
        print(colored("The user couldn't be created", "red"))

def get_user(name):
    s:Session = get_session()
    user = s.query(User).filter_by(name=name).first()
    s.close()
    if user is not None:
        return user
    else:
        return None

def log_in(name, password):
    user = get_user(name)
    if user is not None and password == get_decrypted_password(user.password):
        set_logged_user(user)
        print(f'Logged in as {colored(name, "magenta")}')
        return user
    return None

def log_out():
    if logged_user is not None:
        print(f'User {colored(logged_user.name, "magenta")} {colored("logged out", "red")}')
        remove_logged_user()
        return
    print(colored("You're not logged in", "red"))

def list_users():
    s:Session = get_session()
    users = s.query(User).all()
    s.close()
    for user in users:
        print(colored(f'- {user.name}', "magenta"))


