from setuptools import setup, find_packages
from os import path

here = path.abspath(path.dirname(__file__))

def readme():
    with open('README.md') as f:
        README = f.read()
    return README

setup(
    name='cmpypass',
    version='0.0.1',
    description='Cross-platform password storing solution',
    long_description=readme(),
    long_description_content_type='text/markdown',
    author='Carlos Molero Mata',
    author_email='carlosrooma94@gmail.com',
    license='MIT',

    classifiers=[
        'Development Status :: 3 - Alpha',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: MIT License',
        'Programming Language :: Python :: 3',
    ],


    keywords='keys passwords store db',
    install_requires=["cryptography","termcolor", "tabulate", "sqlalchemy", "pyperclip", "colorama"],
    extras_require={
        'dev': [],
        'test': [],
    },
    packages=find_packages(),
    entry_points={
        'console_scripts':[
            'pypass = cmpypass.main:main'
        ]
    }
)